(*  GREATIS COMMENTED IMAGE                              *)
(*  Copyright (C) 2005-2014 Greatis Software             *)
(*                                                       *)
(*  http://www.greatis.com/delphicb/cmntdimg/            *)

unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Jpeg, CmntdImg, Menus, ToolWin, ComCtrls, ExtDlgs, ImgList;

type
  TfrmMain = class(TForm)
    pmnComment: TPopupMenu;
    mniBringToFront: TMenuItem;
    mniSendToBack: TMenuItem;
    mniProperties: TMenuItem;
    sbxMain: TScrollBox;
    tbrMain: TToolBar;
    imgCommented: TCommentedImage;
    mniDelete: TMenuItem;
    mniSep2: TMenuItem;
    tbtNewComment: TToolButton;
    tbtPaste: TToolButton;
    tbtLoadImage: TToolButton;
    tbtSave: TToolButton;
    tbtCopy: TToolButton;
    tbtLock: TToolButton;
    tbtHide: TToolButton;
    opdImage: TOpenPictureDialog;
    svdImage: TSaveDialog;
    imlToolbar: TImageList;
    tbtLoadObject: TToolButton;
    tbtSaveObject: TToolButton;
    opdObject: TOpenDialog;
    svdObject: TSaveDialog;
    tbtAbout: TToolButton;
    mniSep1: TMenuItem;
    mniDoAutoSize: TMenuItem;
    procedure mniBringToFrontClick(Sender: TObject);
    procedure mniSendToBackClick(Sender: TObject);
    procedure mniCopyClick(Sender: TObject);
    procedure mniPropertiesClick(Sender: TObject);
    procedure imgCommentedCommentDblClick(Sender: TObject;
      Comment: TCommentItem);
    procedure mniDeleteClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure tbtNewCommentClick(Sender: TObject);
    procedure imgCommentedCommentPlace(Sender: TObject;
      Comment: TCommentItem);
    procedure tbtPasteClick(Sender: TObject);
    procedure tbtLoadImageClick(Sender: TObject);
    procedure tbtLockClick(Sender: TObject);
    procedure tbtHideClick(Sender: TObject);
    procedure tbtCopyClick(Sender: TObject);
    procedure tbtSaveClick(Sender: TObject);
    procedure tbtLoadObjectClick(Sender: TObject);
    procedure tbtSaveObjectClick(Sender: TObject);
    procedure tbtAboutClick(Sender: TObject);
    procedure mniDoAutoSizeClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

uses About;

{$R *.DFM}

procedure TfrmMain.mniBringToFrontClick(Sender: TObject);
begin
  imgCommented.MenuComment.BringToFront;
end;

procedure TfrmMain.mniSendToBackClick(Sender: TObject);
begin
  imgCommented.MenuComment.SendToBack;
end;

procedure TfrmMain.mniCopyClick(Sender: TObject);
begin
  imgCommented.CopyToClipboard;
end;

procedure TfrmMain.mniPropertiesClick(Sender: TObject);
begin
  imgCommented.MenuComment.EditProperties;
end;

procedure TfrmMain.imgCommentedCommentDblClick(Sender: TObject;
  Comment: TCommentItem);
begin
  Comment.EditProperties;
  Invalidate;
end;

procedure TfrmMain.mniDeleteClick(Sender: TObject);
begin
  with imgCommented do DeleteComment(MenuComment);
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  imgCommented.GetScreenshot;
  with tbtAbout do
    if Self.ClientHeight<Top+Height then Self.ClientHeight:=Top+Height;
end;

procedure TfrmMain.tbtNewCommentClick(Sender: TObject);
begin
  with tbtNewComment,imgCommented do
    if Down then PlaceComment(True)
    else CancelPlacing;
end;

procedure TfrmMain.imgCommentedCommentPlace(Sender: TObject;
  Comment: TCommentItem);
begin
  tbtNewComment.Down:=False;
  if not Assigned(Comment) then
    MessageBox(
      0,
      'In trial version of Greatis Commented Image only one comment can be created.'#13+
      'To obtain a fully-functional component please visit http://www.greatis.com/delphicb/cmntdimg/order.html',
      'Greatis Commented Image - Trial Version',
      MB_OK or MB_ICONEXCLAMATION);
end;

procedure TfrmMain.tbtPasteClick(Sender: TObject);
begin
  imgCommented.PasteFromClipboard;
  tbtLock.Down:=False;
  tbtHide.Down:=False;
end;

procedure TfrmMain.tbtLoadImageClick(Sender: TObject);
begin
  with opdImage do
    if Execute then
    begin
      imgCommented.LoadImageFromFile(FileName);
      tbtLock.Down:=False;
      tbtHide.Down:=False;
    end;
end;

procedure TfrmMain.tbtLockClick(Sender: TObject);
begin
  with imgCommented do
    if tbtLock.Down then LockComments
    else UnlockComments;
end;

procedure TfrmMain.tbtHideClick(Sender: TObject);
begin
  with imgCommented do
    if tbtHide.Down then HideComments
    else ShowComments;
end;

procedure TfrmMain.tbtCopyClick(Sender: TObject);
begin
  imgCommented.CopyToClipboard;
end;

procedure TfrmMain.tbtSaveClick(Sender: TObject);
begin
  with svdImage do
    if Execute then
      imgCommented.SaveToJpeg(FileName,100);
end;

procedure TfrmMain.tbtLoadObjectClick(Sender: TObject);
begin
  with opdObject do
    if Execute then
    begin
      imgCommented.LoadFromFileWithJpeg(FileName);
      tbtLock.Down:=False;
      tbtHide.Down:=False;
    end;
end;

procedure TfrmMain.tbtSaveObjectClick(Sender: TObject);
begin
  with svdObject do
    if Execute then imgCommented.SaveToFileWithJpeg(FileName,20);
end;

procedure TfrmMain.tbtAboutClick(Sender: TObject);
begin
  frmAbout.ShowModal;
end;

procedure TfrmMain.mniDoAutoSizeClick(Sender: TObject);
begin
  imgCommented.MenuComment.DoAutoSize;
end;

end.
